/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.218 Revision 1.382
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.218 2005/11/22 11:15:34 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.382 2012/02/14 16:08:54 vapier Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
17
18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20
12inherit multilib portability 21inherit multilib portability user
13
14DEPEND="!bootstrap? ( sys-devel/patch )"
15# sys-apps/shadow is needed for useradd, etc, bug #94745.
16 22
17DESCRIPTION="Based on the ${ECLASS} eclass" 23DESCRIPTION="Based on the ${ECLASS} eclass"
18 24
19# Wait for the supplied number of seconds. If no argument is supplied, defaults 25if has "${EAPI:-0}" 0 1 2; then
20# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 26
21# outputting to a terminal, don't wait. For compatability purposes, the argument 27# @FUNCTION: epause
22# must be an integer greater than zero. 28# @USAGE: [seconds]
23# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 29# @DESCRIPTION:
30# Sleep for the specified number of seconds (default of 5 seconds). Useful when
31# printing a message the user should probably be reading and often used in
32# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
33# don't wait at all. Defined in EAPIs 0 1 and 2.
24epause() { 34epause() {
25 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 35 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
26 sleep ${1:-5}
27 fi
28} 36}
29 37
30# Beep the specified number of times (defaults to five). If our output 38# @FUNCTION: ebeep
31# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 39# @USAGE: [number of beeps]
32# don't beep. 40# @DESCRIPTION:
33# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 41# Issue the specified number of beeps (default of 5 beeps). Useful when
42# printing a message the user should probably be reading and often used in
43# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
44# don't beep at all. Defined in EAPIs 0 1 and 2.
34ebeep() { 45ebeep() {
35 local n 46 local n
36 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 47 if [[ -z ${EBEEP_IGNORE} ]] ; then
37 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 48 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
38 echo -ne "\a" 49 echo -ne "\a"
39 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 50 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
40 echo -ne "\a" 51 echo -ne "\a"
41 sleep 1 52 sleep 1
42 done 53 done
43 fi 54 fi
44} 55}
45 56
46# This function generate linker scripts in /usr/lib for dynamic 57else
47# libs in /lib. This is to fix linking problems when you have
48# the .so in /lib, and the .a in /usr/lib. What happens is that
49# in some cases when linking dynamic, the .a in /usr/lib is used
50# instead of the .so in /lib due to gcc/libtool tweaking ld's
51# library search path. This cause many builds to fail.
52# See bug #4411 for more info.
53#
54# To use, simply call:
55#
56# gen_usr_ldscript libfoo.so
57#
58# Note that you should in general use the unversioned name of
59# the library, as ldconfig should usually update it correctly
60# to point to the latest version of the library present.
61#
62# <azarah@gentoo.org> (26 Oct 2002)
63#
64gen_usr_ldscript() {
65 local libdir="$(get_libdir)"
66 # Just make sure it exists
67 dodir /usr/${libdir}
68 58
69 for lib in "${@}" ; do 59ebeep() {
70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 60 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
71 /* GNU ld script 61}
72 Since Gentoo has critical dynamic libraries
73 in /lib, and the static versions in /usr/lib,
74 we need to have a "fake" dynamic lib in /usr/lib,
75 otherwise we run into linking problems.
76 62
77 See bug http://bugs.gentoo.org/4411 for more info. 63epause() {
78 */ 64 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
79 GROUP ( /${libdir}/${lib} ) 65}
80 END_LDSCRIPT 66
81 fperms a+x "/usr/${libdir}/${lib}" 67fi
68
69# @FUNCTION: eqawarn
70# @USAGE: [message]
71# @DESCRIPTION:
72# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
73# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
74# profile.
75if ! declare -F eqawarn >/dev/null ; then
76 eqawarn() {
77 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
78 :
79 }
80fi
81
82# @FUNCTION: ecvs_clean
83# @USAGE: [list of dirs]
84# @DESCRIPTION:
85# Remove CVS directories recursiveley. Useful when a source tarball contains
86# internal CVS directories. Defaults to $PWD.
87ecvs_clean() {
88 [[ -z $* ]] && set -- .
89 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
90 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
91}
92
93# @FUNCTION: esvn_clean
94# @USAGE: [list of dirs]
95# @DESCRIPTION:
96# Remove .svn directories recursiveley. Useful when a source tarball contains
97# internal Subversion directories. Defaults to $PWD.
98esvn_clean() {
99 [[ -z $* ]] && set -- .
100 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
101}
102
103# @FUNCTION: estack_push
104# @USAGE: <stack> [items to push]
105# @DESCRIPTION:
106# Push any number of items onto the specified stack. Pick a name that
107# is a valid variable (i.e. stick to alphanumerics), and push as many
108# items as you like onto the stack at once.
109#
110# The following code snippet will echo 5, then 4, then 3, then ...
111# @CODE
112# estack_push mystack 1 2 3 4 5
113# while estack_pop mystack i ; do
114# echo "${i}"
82 done 115# done
116# @CODE
117estack_push() {
118 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
119 local stack_name="__ESTACK_$1__" ; shift
120 eval ${stack_name}+=\( \"\$@\" \)
83} 121}
84 122
85# Simple function to draw a line consisting of '=' the same length as $* 123# @FUNCTION: estack_pop
86# - only to be used by epatch() 124# @USAGE: <stack> [variable]
87# 125# @DESCRIPTION:
88# <azarah@gentoo.org> (11 Nov 2002) 126# Pop a single item off the specified stack. If a variable is specified,
89# 127# the popped item is stored there. If no more items are available, return
90draw_line() { 128# 1, else return 0. See estack_push for more info.
91 local i=0 129estack_pop() {
92 local str_length="" 130 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
93 131
94 # Handle calls that do not have args, or wc not being installed ... 132 # We use the fugly __estack_xxx var names to avoid collision with
95 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ] 133 # passing back the return value. If we used "local i" and the
96 then 134 # caller ran `estack_pop ... i`, we'd end up setting the local
97 echo "===============================================================" 135 # copy of "i" rather than the caller's copy. The __estack_xxx
136 # garbage is preferable to using $1/$2 everywhere as that is a
137 # bit harder to read.
138 local __estack_name="__ESTACK_$1__" ; shift
139 local __estack_retvar=$1 ; shift
140 eval local __estack_i=\${#${__estack_name}\[@\]}
141 # Don't warn -- let the caller interpret this as a failure
142 # or as normal behavior (akin to `shift`)
143 [[ $(( --__estack_i )) -eq -1 ]] && return 1
144
145 if [[ -n ${__estack_retvar} ]] ; then
146 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
147 fi
148 eval unset ${__estack_name}\[${__estack_i}\]
149}
150
151# @FUNCTION: eshopts_push
152# @USAGE: [options to `set` or `shopt`]
153# @DESCRIPTION:
154# Often times code will want to enable a shell option to change code behavior.
155# Since changing shell options can easily break other pieces of code (which
156# assume the default state), eshopts_push is used to (1) push the current shell
157# options onto a stack and (2) pass the specified arguments to set.
158#
159# If the first argument is '-s' or '-u', we assume you want to call `shopt`
160# rather than `set` as there are some options only available via that.
161#
162# A common example is to disable shell globbing so that special meaning/care
163# may be used with variables/arguments to custom functions. That would be:
164# @CODE
165# eshopts_push -s noglob
166# for x in ${foo} ; do
167# if ...some check... ; then
168# eshopts_pop
98 return 0 169# return 0
99 fi 170# fi
100
101 # Get the length of $*
102 str_length="$(echo -n "$*" | wc -m)"
103
104 while [ "$i" -lt "${str_length}" ]
105 do
106 echo -n "="
107
108 i=$((i + 1))
109 done 171# done
110 172# eshopts_pop
111 echo 173# @CODE
112 174eshopts_push() {
113 return 0 175 if [[ $1 == -[su] ]] ; then
176 estack_push eshopts "$(shopt -p)"
177 [[ $# -eq 0 ]] && return 0
178 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
179 else
180 estack_push eshopts $-
181 [[ $# -eq 0 ]] && return 0
182 set "$@" || die "${FUNCNAME}: bad options to set: $*"
183 fi
114} 184}
115 185
116# Default directory where patches are located 186# @FUNCTION: eshopts_pop
187# @USAGE:
188# @DESCRIPTION:
189# Restore the shell options to the state saved with the corresponding
190# eshopts_push call. See that function for more details.
191eshopts_pop() {
192 local s
193 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
194 if [[ ${s} == "shopt -"* ]] ; then
195 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
196 else
197 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
198 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
199 fi
200}
201
202# @FUNCTION: eumask_push
203# @USAGE: <new umask>
204# @DESCRIPTION:
205# Set the umask to the new value specified while saving the previous
206# value onto a stack. Useful for temporarily changing the umask.
207eumask_push() {
208 estack_push eumask "$(umask)"
209 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
210}
211
212# @FUNCTION: eumask_pop
213# @USAGE:
214# @DESCRIPTION:
215# Restore the previous umask state.
216eumask_pop() {
217 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
218 local s
219 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
220 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
221}
222
223# @VARIABLE: EPATCH_SOURCE
224# @DESCRIPTION:
225# Default directory to search for patches.
117EPATCH_SOURCE="${WORKDIR}/patch" 226EPATCH_SOURCE="${WORKDIR}/patch"
118# Default extension for patches 227# @VARIABLE: EPATCH_SUFFIX
228# @DESCRIPTION:
229# Default extension for patches (do not prefix the period yourself).
119EPATCH_SUFFIX="patch.bz2" 230EPATCH_SUFFIX="patch.bz2"
231# @VARIABLE: EPATCH_OPTS
232# @DESCRIPTION:
120# Default options for patch 233# Default options for patch:
234# @CODE
121# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 235# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
122# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 236# --no-backup-if-mismatch - do not leave .orig files behind
237# -E - automatically remove empty files
238# @CODE
123EPATCH_OPTS="-g0 --no-backup-if-mismatch" 239EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
240# @VARIABLE: EPATCH_EXCLUDE
241# @DESCRIPTION:
124# List of patches not to apply. Not this is only file names, 242# List of patches not to apply. Note this is only file names,
125# and not the full path .. 243# and not the full path. Globs accepted.
126EPATCH_EXCLUDE="" 244EPATCH_EXCLUDE=""
245# @VARIABLE: EPATCH_SINGLE_MSG
246# @DESCRIPTION:
127# Change the printed message for a single patch. 247# Change the printed message for a single patch.
128EPATCH_SINGLE_MSG="" 248EPATCH_SINGLE_MSG=""
249# @VARIABLE: EPATCH_MULTI_MSG
250# @DESCRIPTION:
129# Change the printed message for multiple patches. 251# Change the printed message for multiple patches.
130EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 252EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
131# Force applying bulk patches even if not following the style: 253# @VARIABLE: EPATCH_FORCE
132# 254# @DESCRIPTION:
133# ??_${ARCH}_foo.${EPATCH_SUFFIX} 255# Only require patches to match EPATCH_SUFFIX rather than the extended
134# 256# arch naming style.
135EPATCH_FORCE="no" 257EPATCH_FORCE="no"
136 258
137# This function is for bulk patching, or in theory for just one 259# @FUNCTION: epatch
138# or two patches. 260# @USAGE: [patches] [dirs of patches]
261# @DESCRIPTION:
262# epatch is designed to greatly simplify the application of patches. It can
263# process patch files directly, or directories of patches. The patches may be
264# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
265# the -p option as epatch will automatically attempt -p0 to -p5 until things
266# apply successfully.
139# 267#
140# It should work with .bz2, .gz, .zip and plain text patches. 268# If you do not specify any options, then epatch will default to the directory
141# Currently all patches should be the same format. 269# specified by EPATCH_SOURCE.
142# 270#
143# You do not have to specify '-p' option to patch, as it will 271# When processing directories, epatch will apply all patches that match:
144# try with -p0 to -p5 until it succeed, or fail at -p5. 272# @CODE
145# 273# if ${EPATCH_FORCE} != "yes"
146# Above EPATCH_* variables can be used to control various defaults,
147# bug they should be left as is to ensure an ebuild can rely on
148# them for.
149#
150# Patches are applied in current directory.
151#
152# Bulk Patches should preferibly have the form of:
153#
154# ??_${ARCH}_foo.${EPATCH_SUFFIX} 274# ??_${ARCH}_foo.${EPATCH_SUFFIX}
275# else
276# *.${EPATCH_SUFFIX}
277# @CODE
278# The leading ?? are typically numbers used to force consistent patch ordering.
279# The arch field is used to apply patches only for the host architecture with
280# the special value of "all" means apply for everyone. Note that using values
281# other than "all" is highly discouraged -- you should apply patches all the
282# time and let architecture details be detected at configure/compile time.
155# 283#
156# For example: 284# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
285# for patches to apply.
157# 286#
158# 01_all_misc-fix.patch.bz2 287# Refer to the other EPATCH_xxx variables for more customization of behavior.
159# 02_sparc_another-fix.patch.bz2
160#
161# This ensures that there are a set order, and you can have ARCH
162# specific patches.
163#
164# If you however give an argument to epatch(), it will treat it as a
165# single patch that need to be applied if its a file. If on the other
166# hand its a directory, it will set EPATCH_SOURCE to this.
167#
168# <azarah@gentoo.org> (10 Nov 2002)
169#
170epatch() { 288epatch() {
171 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; } 289 _epatch_draw_line() {
172 local PIPE_CMD="" 290 # create a line of same length as input string
173 local STDERR_TARGET="${T}/$$.out" 291 [[ -z $1 ]] && set "$(printf "%65s" '')"
174 local PATCH_TARGET="${T}/$$.patch" 292 echo "${1//?/=}"
175 local PATCH_SUFFIX="" 293 }
176 local SINGLE_PATCH="no"
177 local x=""
178 294
179 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 295 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
180 296
181 if [ "$#" -gt 1 ] 297 # Let the rest of the code process one user arg at a time --
182 then 298 # each arg may expand into multiple patches, and each arg may
299 # need to start off with the default global EPATCH_xxx values
300 if [[ $# -gt 1 ]] ; then
183 local m="" 301 local m
184 for m in "$@" ; do 302 for m in "$@" ; do
185 epatch "${m}" 303 epatch "${m}"
186 done 304 done
187 return 0 305 return 0
188 fi 306 fi
189 307
190 if [ -n "$1" -a -f "$1" ] 308 local SINGLE_PATCH="no"
191 then 309 # no args means process ${EPATCH_SOURCE}
310 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
311
312 if [[ -f $1 ]] ; then
192 SINGLE_PATCH="yes" 313 SINGLE_PATCH="yes"
193 314 set -- "$1"
194 local EPATCH_SOURCE="$1" 315 # Use the suffix from the single patch (localize it); the code
316 # below will find the suffix for us
195 local EPATCH_SUFFIX="${1##*\.}" 317 local EPATCH_SUFFIX=$1
196 318
197 elif [ -n "$1" -a -d "$1" ] 319 elif [[ -d $1 ]] ; then
198 then 320 # Some people like to make dirs of patches w/out suffixes (vim)
199 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 321 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
200 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 322
323 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
324 # Re-use EPATCH_SOURCE as a search dir
325 epatch "${EPATCH_SOURCE}/$1"
326 return $?
327
328 else
329 # sanity check ... if it isn't a dir or file, wtf man ?
330 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
331 echo
332 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
333 eerror
334 eerror " ${EPATCH_SOURCE}"
335 eerror " ( ${EPATCH_SOURCE##*/} )"
336 echo
337 die "Cannot find \$EPATCH_SOURCE!"
338 fi
339
340 local PIPE_CMD
341 case ${EPATCH_SUFFIX##*\.} in
342 xz) PIPE_CMD="xz -dc" ;;
343 lzma) PIPE_CMD="lzma -dc" ;;
344 bz2) PIPE_CMD="bzip2 -dc" ;;
345 gz|Z|z) PIPE_CMD="gzip -dc" ;;
346 ZIP|zip) PIPE_CMD="unzip -p" ;;
347 *) ;;
348 esac
349
350 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
351
352 local x
353 for x in "$@" ; do
354 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
355 # didn't match anything, ignore continue on
356 [[ ! -f ${x} ]] && continue
357
358 local patchname=${x##*/}
359
360 # Apply single patches, or forced sets of patches, or
361 # patches with ARCH dependant names.
362 # ???_arch_foo.patch
363 # Else, skip this input altogether
364 local a=${patchname#*_} # strip the ???_
365 a=${a%%_*} # strip the _foo.patch
366 if ! [[ ${SINGLE_PATCH} == "yes" || \
367 ${EPATCH_FORCE} == "yes" || \
368 ${a} == all || \
369 ${a} == ${ARCH} ]]
201 then 370 then
202 local EPATCH_SOURCE="$1/*" 371 continue
372 fi
373
374 # Let people filter things dynamically
375 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
376 # let people use globs in the exclude
377 eshopts_push -o noglob
378
379 local ex
380 for ex in ${EPATCH_EXCLUDE} ; do
381 if [[ ${patchname} == ${ex} ]] ; then
382 eshopts_pop
383 continue 2
384 fi
385 done
386
387 eshopts_pop
388 fi
389
390 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
391 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
392 einfo "${EPATCH_SINGLE_MSG}"
393 else
394 einfo "Applying ${patchname} ..."
395 fi
203 else 396 else
204 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 397 einfo " ${patchname} ..."
205 fi 398 fi
206 else 399
207 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 400 # most of the time, there will only be one run per unique name,
208 then 401 # but if there are more, make sure we get unique log filenames
209 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 402 local STDERR_TARGET="${T}/${patchname}.out"
210 then 403 if [[ -e ${STDERR_TARGET} ]] ; then
211 EPATCH_SOURCE="$1" 404 STDERR_TARGET="${T}/${patchname}-$$.out"
405 fi
406
407 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
408
409 # Decompress the patch if need be
410 local count=0
411 local PATCH_TARGET
412 if [[ -n ${PIPE_CMD} ]] ; then
413 PATCH_TARGET="${T}/$$.patch"
414 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
415
416 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
417 echo
418 eerror "Could not extract patch!"
419 #die "Could not extract patch!"
420 count=5
421 break
212 fi 422 fi
423 else
424 PATCH_TARGET=${x}
425 fi
213 426
427 # Check for absolute paths in patches. If sandbox is disabled,
428 # people could (accidently) patch files in the root filesystem.
429 # Or trigger other unpleasantries #237667. So disallow -p0 on
430 # such patches.
431 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
432 if [[ -n ${abs_paths} ]] ; then
433 count=1
434 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
435 fi
436 # Similar reason, but with relative paths.
437 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
438 if [[ -n ${rel_paths} ]] ; then
439 eqawarn "QA Notice: Your patch uses relative paths '../'."
440 eqawarn " In the future this will cause a failure."
441 eqawarn "${rel_paths}"
442 fi
443
444 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
445 while [[ ${count} -lt 5 ]] ; do
446 # Generate some useful debug info ...
447 (
448 _epatch_draw_line "***** ${patchname} *****"
214 echo 449 echo
215 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 450 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
451 echo
452 _epatch_draw_line "***** ${patchname} *****"
453 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
454 ret=$?
455 echo
456 echo "patch program exited with status ${ret}"
457 exit ${ret}
458 ) >> "${STDERR_TARGET}"
459
460 if [ $? -eq 0 ] ; then
461 (
462 _epatch_draw_line "***** ${patchname} *****"
463 echo
464 echo "ACTUALLY APPLYING ${patchname} ..."
465 echo
466 _epatch_draw_line "***** ${patchname} *****"
467 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
468 ret=$?
469 echo
470 echo "patch program exited with status ${ret}"
471 exit ${ret}
472 ) >> "${STDERR_TARGET}"
473
474 if [ $? -ne 0 ] ; then
475 echo
476 eerror "A dry-run of patch command succeeded, but actually"
477 eerror "applying the patch failed!"
478 #die "Real world sux compared to the dreamworld!"
479 count=5
480 fi
481 break
482 fi
483
484 : $(( count++ ))
485 done
486
487 # if we had to decompress the patch, delete the temp one
488 if [[ -n ${PIPE_CMD} ]] ; then
489 rm -f "${PATCH_TARGET}"
490 fi
491
492 if [[ ${count} -ge 5 ]] ; then
493 echo
494 eerror "Failed Patch: ${patchname} !"
495 eerror " ( ${PATCH_TARGET} )"
216 eerror 496 eerror
217 eerror " ${EPATCH_SOURCE}" 497 eerror "Include in your bugreport the contents of:"
218 eerror " ( ${EPATCH_SOURCE##*/} )" 498 eerror
499 eerror " ${STDERR_TARGET}"
219 echo 500 echo
220 die "Cannot find \$EPATCH_SOURCE!"
221 fi
222
223 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
224 fi
225
226 case ${EPATCH_SUFFIX##*\.} in
227 bz2)
228 PIPE_CMD="bzip2 -dc"
229 PATCH_SUFFIX="bz2"
230 ;;
231 gz|Z|z)
232 PIPE_CMD="gzip -dc"
233 PATCH_SUFFIX="gz"
234 ;;
235 ZIP|zip)
236 PIPE_CMD="unzip -p"
237 PATCH_SUFFIX="zip"
238 ;;
239 *)
240 PIPE_CMD="cat"
241 PATCH_SUFFIX="patch"
242 ;;
243 esac
244
245 if [ "${SINGLE_PATCH}" = "no" ]
246 then
247 einfo "${EPATCH_MULTI_MSG}"
248 fi
249 for x in ${EPATCH_SOURCE}
250 do
251 # New ARCH dependant patch naming scheme ...
252 #
253 # ???_arch_foo.patch
254 #
255 if [ -f ${x} ] && \
256 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
257 [ "${EPATCH_FORCE}" = "yes" ])
258 then
259 local count=0
260 local popts="${EPATCH_OPTS}"
261 local patchname=${x##*/}
262
263 if [ -n "${EPATCH_EXCLUDE}" ]
264 then
265 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
266 then
267 continue
268 fi
269 fi
270
271 if [ "${SINGLE_PATCH}" = "yes" ]
272 then
273 if [ -n "${EPATCH_SINGLE_MSG}" ]
274 then
275 einfo "${EPATCH_SINGLE_MSG}"
276 else
277 einfo "Applying ${patchname} ..."
278 fi
279 else
280 einfo " ${patchname} ..."
281 fi
282
283 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
284 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
285
286 # Allow for prefix to differ ... im lazy, so shoot me :/
287 while [ "${count}" -lt 5 ]
288 do
289 # Generate some useful debug info ...
290 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
291 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
292
293 if [ "${PATCH_SUFFIX}" != "patch" ]
294 then
295 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
296 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
297 else
298 PATCH_TARGET="${x}"
299 fi
300
301 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
302 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
303
304 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
305 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
306
307 if [ "${PATCH_SUFFIX}" != "patch" ]
308 then
309 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
310 then
311 echo
312 eerror "Could not extract patch!"
313 #die "Could not extract patch!"
314 count=5
315 break
316 fi
317 fi
318
319 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
320 then
321 draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
322 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
323 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
324 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
325 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
326
327 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
328 _epatch_assert
329
330 if [ "$?" -ne 0 ]
331 then
332 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
333 echo
334 eerror "A dry-run of patch command succeeded, but actually"
335 eerror "applying the patch failed!"
336 #die "Real world sux compared to the dreamworld!"
337 count=5
338 fi
339
340 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
341
342 break
343 fi
344
345 count=$((count + 1))
346 done
347
348 if [ "${PATCH_SUFFIX}" != "patch" ]
349 then
350 rm -f ${PATCH_TARGET}
351 fi
352
353 if [ "${count}" -eq 5 ]
354 then
355 echo
356 eerror "Failed Patch: ${patchname} !"
357 eerror " ( ${PATCH_TARGET} )"
358 eerror
359 eerror "Include in your bugreport the contents of:"
360 eerror
361 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
362 echo
363 die "Failed Patch: ${patchname}!" 501 die "Failed Patch: ${patchname}!"
364 fi 502 fi
365 503
366 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 504 # if everything worked, delete the patch log
367 505 rm -f "${STDERR_TARGET}"
368 eend 0 506 eend 0
369 fi
370 done 507 done
371 if [ "${SINGLE_PATCH}" = "no" ] 508
372 then 509 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
373 einfo "Done with patching" 510 : # everything worked
511}
512
513# @FUNCTION: epatch_user
514# @USAGE:
515# @DESCRIPTION:
516# Applies user-provided patches to the source tree. The patches are
517# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
518# of these three directories to exist will be the one to use, ignoring
519# any more general directories which might exist as well.
520#
521# User patches are intended for quick testing of patches without ebuild
522# modifications, as well as for permanent customizations a user might
523# desire. Obviously, there can be no official support for arbitrarily
524# patched ebuilds. So whenever a build log in a bug report mentions that
525# user patches were applied, the user should be asked to reproduce the
526# problem without these.
527#
528# Not all ebuilds do call this function, so placing patches in the
529# stated directory might or might not work, depending on the package and
530# the eclasses it inherits and uses. It is safe to call the function
531# repeatedly, so it is always possible to add a call at the ebuild
532# level. The first call is the time when the patches will be
533# applied.
534#
535# Ideally, this function should be called after gentoo-specific patches
536# have been applied, so that their code can be modified as well, but
537# before calls to e.g. eautoreconf, as the user patches might affect
538# autotool input files as well.
539epatch_user() {
540 [[ $# -ne 0 ]] && die "epatch_user takes no options"
541
542 # Allow multiple calls to this function; ignore all but the first
543 local applied="${T}/epatch_user.applied"
544 [[ -e ${applied} ]] && return 2
545
546 # don't clobber any EPATCH vars that the parent might want
547 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
548 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}; do
549 EPATCH_SOURCE=${base}/${CTARGET}/${check}
550 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
551 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
552 if [[ -d ${EPATCH_SOURCE} ]] ; then
553 EPATCH_SOURCE=${EPATCH_SOURCE} \
554 EPATCH_SUFFIX="patch" \
555 EPATCH_FORCE="yes" \
556 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
557 epatch
558 echo "${EPATCH_SOURCE}" > "${applied}"
559 return 0
374 fi 560 fi
561 done
562 echo "none" > "${applied}"
563 return 1
375} 564}
376 565
566# @FUNCTION: emktemp
567# @USAGE: [temp dir]
568# @DESCRIPTION:
377# Cheap replacement for when debianutils (and thus mktemp) 569# Cheap replacement for when debianutils (and thus mktemp)
378# does not exist on the users system 570# does not exist on the users system.
379# vapier@gentoo.org
380#
381# Takes just 1 optional parameter (the directory to create tmpfile in)
382emktemp() { 571emktemp() {
383 local exe="touch" 572 local exe="touch"
384 [[ $1 == -d ]] && exe="mkdir" && shift 573 [[ $1 == -d ]] && exe="mkdir" && shift
385 local topdir=$1 574 local topdir=$1
386 575
388 [[ -z ${T} ]] \ 577 [[ -z ${T} ]] \
389 && topdir="/tmp" \ 578 && topdir="/tmp" \
390 || topdir=${T} 579 || topdir=${T}
391 fi 580 fi
392 581
393 if [[ -z $(type -p mktemp) ]] ; then 582 if ! type -P mktemp > /dev/null ; then
583 # system lacks `mktemp` so we have to fake it
394 local tmp=/ 584 local tmp=/
395 while [[ -e ${tmp} ]] ; do 585 while [[ -e ${tmp} ]] ; do
396 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 586 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
397 done 587 done
398 ${exe} "${tmp}" || ${exe} -p "${tmp}" 588 ${exe} "${tmp}" || ${exe} -p "${tmp}"
399 echo "${tmp}" 589 echo "${tmp}"
400 else 590 else
591 # the args here will give slightly wierd names on BSD,
592 # but should produce a usable file on all userlands
401 [[ ${exe} == "touch" ]] \ 593 if [[ ${exe} == "touch" ]] ; then
402 && exe="-p" \ 594 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
403 || exe="-d"
404 mktemp ${exe} "${topdir}"
405 fi
406}
407
408# Small wrapper for getent (Linux), nidump (Mac OS X),
409# and pw (FreeBSD) used in enewuser()/enewgroup()
410# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
411# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
412#
413# egetent(database, key)
414egetent() {
415 case ${CHOST} in
416 *-darwin*)
417 case "$2" in
418 *[!0-9]*) # Non numeric
419 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
420 ;;
421 *) # Numeric
422 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
423 ;;
424 esac
425 ;;
426 *-freebsd*)
427 local opts action="user"
428 [[ $1 == "passwd" ]] || action="group"
429
430 # lookup by uid/gid
431 if [[ $2 == [[:digit:]]* ]] ; then
432 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
433 fi
434
435 pw show ${action} ${opts} "$2" -q
436 ;;
437 *-netbsd*|*-openbsd*)
438 grep "$2:\*:" /etc/$1
439 ;;
440 *)
441 type -p nscd >& /dev/null && nscd -i "$1"
442 getent "$1" "$2"
443 ;;
444 esac
445}
446
447# Simplify/standardize adding users to the system
448# vapier@gentoo.org
449#
450# enewuser(username, uid, shell, homedir, groups, extra options)
451#
452# Default values if you do not specify any:
453# username: REQUIRED !
454# uid: next available (see useradd(8))
455# note: pass -1 to get default behavior
456# shell: /bin/false
457# homedir: /dev/null
458# groups: none
459# extra: comment of 'added by portage for ${PN}'
460enewuser() {
461 # get the username
462 local euser=$1; shift
463 if [[ -z ${euser} ]] ; then
464 eerror "No username specified !"
465 die "Cannot call enewuser without a username"
466 fi
467
468 # lets see if the username already exists
469 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then
470 return 0
471 fi
472 einfo "Adding user '${euser}' to your system ..."
473
474 # options to pass to useradd
475 local opts=
476
477 # handle uid
478 local euid=$1; shift
479 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then
480 if [[ ${euid} -gt 0 ]] ; then
481 if [[ ! -z $(egetent passwd ${euid}) ]] ; then
482 euid="next"
483 fi
484 else 595 else
485 eerror "Userid given but is not greater than 0 !" 596 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
486 die "${euid} is not a valid UID"
487 fi
488 else
489 euid="next"
490 fi
491 if [[ ${euid} == "next" ]] ; then
492 for euid in $(seq 101 999) ; do
493 [[ -z $(egetent passwd ${euid}) ]] && break
494 done
495 fi
496 opts="${opts} -u ${euid}"
497 einfo " - Userid: ${euid}"
498
499 # handle shell
500 local eshell=$1; shift
501 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
502 if [[ ! -e ${eshell} ]] ; then
503 eerror "A shell was specified but it does not exist !"
504 die "${eshell} does not exist"
505 fi
506 else
507 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
508 [[ -x ${ROOT}${shell} ]] && break
509 done
510
511 if [[ ${shell} == "/dev/null" ]] ; then
512 eerror "Unable to identify the shell to use"
513 die "Unable to identify the shell to use"
514 fi
515
516 eshell=${shell}
517 fi
518 einfo " - Shell: ${eshell}"
519 opts="${opts} -s ${eshell}"
520
521 # handle homedir
522 local ehome=$1; shift
523 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
524 ehome="/dev/null"
525 fi
526 einfo " - Home: ${ehome}"
527 opts="${opts} -d ${ehome}"
528
529 # handle groups
530 local egroups=$1; shift
531 if [[ ! -z ${egroups} ]] ; then
532 local oldifs=${IFS}
533 local defgroup="" exgroups=""
534
535 export IFS=","
536 for g in ${egroups} ; do
537 export IFS=${oldifs}
538 if [[ -z $(egetent group "${g}") ]] ; then
539 eerror "You must add group ${g} to the system first"
540 die "${g} is not a valid GID"
541 fi 597 fi
542 if [[ -z ${defgroup} ]] ; then
543 defgroup=${g}
544 else
545 exgroups="${exgroups},${g}"
546 fi
547 export IFS=","
548 done
549 export IFS=${oldifs}
550
551 opts="${opts} -g ${defgroup}"
552 if [[ ! -z ${exgroups} ]] ; then
553 opts="${opts} -G ${exgroups:1}"
554 fi 598 fi
555 else
556 egroups="(none)"
557 fi
558 einfo " - Groups: ${egroups}"
559
560 # handle extra and add the user
561 local oldsandbox=${SANDBOX_ON}
562 export SANDBOX_ON="0"
563 case ${CHOST} in
564 *-darwin*)
565 ### Make the user
566 if [[ -z $@ ]] ; then
567 dscl . create /users/${euser} uid ${euid}
568 dscl . create /users/${euser} shell ${eshell}
569 dscl . create /users/${euser} home ${ehome}
570 dscl . create /users/${euser} realname "added by portage for ${PN}"
571 ### Add the user to the groups specified
572 local oldifs=${IFS}
573 export IFS=","
574 for g in ${egroups} ; do
575 dscl . merge /groups/${g} users ${euser}
576 done
577 export IFS=${oldifs}
578 else
579 einfo "Extra options are not supported on Darwin yet"
580 einfo "Please report the ebuild along with the info below"
581 einfo "eextra: $@"
582 die "Required function missing"
583 fi
584 ;;
585 *-freebsd*)
586 if [[ -z $@ ]] ; then
587 pw useradd ${euser} ${opts} \
588 -c "added by portage for ${PN}" \
589 die "enewuser failed"
590 else
591 einfo " - Extra: $@"
592 pw useradd ${euser} ${opts} \
593 "$@" || die "enewuser failed"
594 fi
595 ;;
596
597 *-netbsd*)
598 if [[ -z $@ ]] ; then
599 useradd ${opts} ${euser} || die "enewuser failed"
600 else
601 einfo " - Extra: $@"
602 useradd ${opts} ${euser} "$@" || die "enewuser failed"
603 fi
604 ;;
605
606 *-openbsd*)
607 if [[ -z $@ ]] ; then
608 useradd -u ${euid} -s ${eshell} \
609 -d ${ehome} -c "Added by portage for ${PN}" \
610 -g ${egroups} ${euser} || die "enewuser failed"
611 else
612 einfo " - Extra: $@"
613 useradd -u ${euid} -s ${eshell} \
614 -d ${ehome} -c "Added by portage for ${PN}" \
615 -g ${egroups} ${euser} "$@" || die "enewuser failed"
616 fi
617 ;;
618
619 *)
620 if [[ -z $@ ]] ; then
621 useradd ${opts} ${euser} \
622 -c "added by portage for ${PN}" \
623 || die "enewuser failed"
624 else
625 einfo " - Extra: $@"
626 useradd ${opts} ${euser} "$@" \
627 || die "enewuser failed"
628 fi
629 ;;
630 esac
631
632 if [[ ! -e ${ROOT}/${ehome} ]] ; then
633 einfo " - Creating ${ehome} in ${ROOT}"
634 mkdir -p "${ROOT}/${ehome}"
635 chown ${euser} "${ROOT}/${ehome}"
636 chmod 755 "${ROOT}/${ehome}"
637 fi
638
639 export SANDBOX_ON=${oldsandbox}
640} 599}
641 600
642# Simplify/standardize adding groups to the system 601# @FUNCTION: edos2unix
643# vapier@gentoo.org 602# @USAGE: <file> [more files ...]
644# 603# @DESCRIPTION:
645# enewgroup(group, gid) 604# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
646# 605# to remove all of these text utilities from DEPEND variables because this
647# Default values if you do not specify any: 606# is a script based solution. Just give it a list of files to convert and
648# groupname: REQUIRED ! 607# they will all be changed from the DOS CRLF format to the UNIX LF format.
649# gid: next available (see groupadd(8))
650# extra: none
651enewgroup() {
652 # get the group
653 local egroup="$1"; shift
654 if [ -z "${egroup}" ]
655 then
656 eerror "No group specified !"
657 die "Cannot call enewgroup without a group"
658 fi
659
660 # see if group already exists
661 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ]
662 then
663 return 0
664 fi
665 einfo "Adding group '${egroup}' to your system ..."
666
667 # options to pass to useradd
668 local opts=
669
670 # handle gid
671 local egid="$1"; shift
672 if [ ! -z "${egid}" ]
673 then
674 if [ "${egid}" -gt 0 ]
675 then
676 if [ -z "`egetent group ${egid}`" ]
677 then
678 if [[ "${CHOST}" == *-darwin* ]]; then
679 opts="${opts} ${egid}"
680 else
681 opts="${opts} -g ${egid}"
682 fi
683 else
684 egid="next available; requested gid taken"
685 fi
686 else
687 eerror "Groupid given but is not greater than 0 !"
688 die "${egid} is not a valid GID"
689 fi
690 else
691 egid="next available"
692 fi
693 einfo " - Groupid: ${egid}"
694
695 # handle extra
696 local eextra="$@"
697 opts="${opts} ${eextra}"
698
699 # add the group
700 local oldsandbox="${SANDBOX_ON}"
701 export SANDBOX_ON="0"
702 case ${CHOST} in
703 *-darwin*)
704 if [ ! -z "${eextra}" ];
705 then
706 einfo "Extra options are not supported on Darwin/OS X yet"
707 einfo "Please report the ebuild along with the info below"
708 einfo "eextra: ${eextra}"
709 die "Required function missing"
710 fi
711
712 # If we need the next available
713 case ${egid} in
714 *[!0-9]*) # Non numeric
715 for egid in $(seq 101 999); do
716 [ -z "`egetent group ${egid}`" ] && break
717 done
718 esac
719 dscl . create /groups/${egroup} gid ${egid}
720 dscl . create /groups/${egroup} passwd '*'
721 ;;
722
723 *-freebsd*)
724 case ${egid} in
725 *[!0-9]*) # Non numeric
726 for egid in $(seq 101 999); do
727 [ -z "`egetent group ${egid}`" ] && break
728 done
729 esac
730 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
731 ;;
732
733 *-netbsd*)
734 case ${egid} in
735 *[!0-9]*) # Non numeric
736 for egid in $(seq 101 999); do
737 [ -z "`egetent group ${egid}`" ] && break
738 done
739 esac
740 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
741 ;;
742
743 *)
744 groupadd ${opts} ${egroup} || die "enewgroup failed"
745 ;;
746 esac
747 export SANDBOX_ON="${oldsandbox}"
748}
749
750# Simple script to replace 'dos2unix' binaries
751# vapier@gentoo.org
752#
753# edos2unix(file, <more files> ...)
754edos2unix() { 608edos2unix() {
755 for f in "$@" 609 [[ $# -eq 0 ]] && return 0
756 do 610 sed -i 's/\r$//' -- "$@" || die
757 cp "${f}" ${T}/edos2unix
758 sed 's/\r$//' ${T}/edos2unix > "${f}"
759 done
760} 611}
761 612
762 613# @FUNCTION: make_desktop_entry
763############################################################## 614# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
764# START: Handle .desktop files and menu entries # 615# @DESCRIPTION:
765# maybe this should be separated into a new eclass some time #
766# lanius@gentoo.org #
767##############################################################
768
769# Make a desktop file ! 616# Make a .desktop file.
770# Great for making those icons in kde/gnome startmenu !
771# Amaze your friends ! Get the women ! Join today !
772# 617#
773# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 618# @CODE
774#
775# binary: what binary does the app run with ? 619# binary: what command does the app run with ?
776# name: the name that will show up in the menu 620# name: the name that will show up in the menu
777# icon: give your little like a pretty little icon ... 621# icon: give your little like a pretty little icon ...
778# this can be relative (to /usr/share/pixmaps) or 622# this can be relative (to /usr/share/pixmaps) or
779# a full path to an icon 623# a full path to an icon
780# type: what kind of application is this ? for categories: 624# type: what kind of application is this?
781# http://www.freedesktop.org/Standards/desktop-entry-spec 625# for categories:
782# path: if your app needs to startup in a specific dir 626# http://standards.freedesktop.org/menu-spec/latest/apa.html
627# if unset, function tries to guess from package's category
628# fields: extra fields to append to the desktop file; a printf string
629# @CODE
783make_desktop_entry() { 630make_desktop_entry() {
784 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 631 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
785 632
786 local exec=${1} 633 local exec=${1}
787 local name=${2:-${PN}} 634 local name=${2:-${PN}}
788 local icon=${3:-${PN}.png} 635 local icon=${3:-${PN}}
789 local type=${4} 636 local type=${4}
790 local path=${5} 637 local fields=${5}
791 638
792 if [[ -z ${type} ]] ; then 639 if [[ -z ${type} ]] ; then
793 local catmaj=${CATEGORY%%-*} 640 local catmaj=${CATEGORY%%-*}
794 local catmin=${CATEGORY##*-} 641 local catmin=${CATEGORY##*-}
795 case ${catmaj} in 642 case ${catmaj} in
796 app) 643 app)
797 case ${catmin} in 644 case ${catmin} in
645 accessibility) type=Accessibility;;
798 admin) type=System;; 646 admin) type=System;;
647 antivirus) type=System;;
648 arch) type=Archiving;;
649 backup) type=Archiving;;
799 cdr) type=DiscBurning;; 650 cdr) type=DiscBurning;;
800 dicts) type=Dictionary;; 651 dicts) type=Dictionary;;
652 doc) type=Documentation;;
801 editors) type=TextEditor;; 653 editors) type=TextEditor;;
802 emacs) type=TextEditor;; 654 emacs) type=TextEditor;;
803 emulation) type=Emulator;; 655 emulation) type=Emulator;;
804 laptop) type=HardwareSettings;; 656 laptop) type=HardwareSettings;;
805 office) type=Office;; 657 office) type=Office;;
658 pda) type=PDA;;
806 vim) type=TextEditor;; 659 vim) type=TextEditor;;
807 xemacs) type=TextEditor;; 660 xemacs) type=TextEditor;;
808 *) type=;;
809 esac 661 esac
810 ;; 662 ;;
811 663
812 dev) 664 dev)
813 type="Development" 665 type="Development"
814 ;; 666 ;;
815 667
816 games) 668 games)
817 case ${catmin} in 669 case ${catmin} in
818 action) type=ActionGame;; 670 action|fps) type=ActionGame;;
819 arcade) type=ArcadeGame;; 671 arcade) type=ArcadeGame;;
820 board) type=BoardGame;; 672 board) type=BoardGame;;
821 kid) type=KidsGame;;
822 emulation) type=Emulator;; 673 emulation) type=Emulator;;
674 kids) type=KidsGame;;
823 puzzle) type=LogicGame;; 675 puzzle) type=LogicGame;;
676 roguelike) type=RolePlaying;;
824 rpg) type=RolePlaying;; 677 rpg) type=RolePlaying;;
825 roguelike) type=RolePlaying;;
826 simulation) type=Simulation;; 678 simulation) type=Simulation;;
827 sports) type=SportsGame;; 679 sports) type=SportsGame;;
828 strategy) type=StrategyGame;; 680 strategy) type=StrategyGame;;
829 *) type=;;
830 esac 681 esac
831 type="Game;${type}" 682 type="Game;${type}"
832 ;; 683 ;;
833 684
685 gnome)
686 type="Gnome;GTK"
687 ;;
688
689 kde)
690 type="KDE;Qt"
691 ;;
692
834 mail) 693 mail)
835 type="Network;Email" 694 type="Network;Email"
836 ;; 695 ;;
837 696
838 media) 697 media)
839 case ${catmin} in 698 case ${catmin} in
699 gfx)
840 gfx) type=Graphics;; 700 type=Graphics
701 ;;
702 *)
703 case ${catmin} in
841 radio) type=Tuner;; 704 radio) type=Tuner;;
842 sound) type=Audio;; 705 sound) type=Audio;;
843 tv) type=TV;; 706 tv) type=TV;;
844 video) type=Video;; 707 video) type=Video;;
845 *) type=;; 708 esac
709 type="AudioVideo;${type}"
710 ;;
846 esac 711 esac
847 type="AudioVideo;${type}"
848 ;; 712 ;;
849 713
850 net) 714 net)
851 case ${catmin} in 715 case ${catmin} in
852 dialup) type=Dialup;; 716 dialup) type=Dialup;;
855 irc) type=IRCClient;; 719 irc) type=IRCClient;;
856 mail) type=Email;; 720 mail) type=Email;;
857 news) type=News;; 721 news) type=News;;
858 nntp) type=News;; 722 nntp) type=News;;
859 p2p) type=FileTransfer;; 723 p2p) type=FileTransfer;;
860 *) type=;; 724 voip) type=Telephony;;
861 esac 725 esac
862 type="Network;${type}" 726 type="Network;${type}"
863 ;; 727 ;;
864 728
865 sci) 729 sci)
866 case ${catmin} in 730 case ${catmin} in
867 astro*) type=Astronomy;; 731 astro*) type=Astronomy;;
868 bio*) type=Biology;; 732 bio*) type=Biology;;
869 calc*) type=Calculator;; 733 calc*) type=Calculator;;
870 chem*) type=Chemistry;; 734 chem*) type=Chemistry;;
735 elec*) type=Electronics;;
871 geo*) type=Geology;; 736 geo*) type=Geology;;
872 math*) type=Math;; 737 math*) type=Math;;
873 *) type=;; 738 physics) type=Physics;;
739 visual*) type=DataVisualization;;
874 esac 740 esac
875 type="Science;${type}" 741 type="Education;Science;${type}"
742 ;;
743
744 sys)
745 type="System"
876 ;; 746 ;;
877 747
878 www) 748 www)
879 case ${catmin} in 749 case ${catmin} in
880 client) type=WebBrowser;; 750 client) type=WebBrowser;;
881 *) type=;;
882 esac 751 esac
883 type="Network" 752 type="Network;${type}"
884 ;; 753 ;;
885 754
886 *) 755 *)
887 type= 756 type=
888 ;; 757 ;;
891 if [ "${SLOT}" == "0" ] ; then 760 if [ "${SLOT}" == "0" ] ; then
892 local desktop_name="${PN}" 761 local desktop_name="${PN}"
893 else 762 else
894 local desktop_name="${PN}-${SLOT}" 763 local desktop_name="${PN}-${SLOT}"
895 fi 764 fi
765 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
896 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 766 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
897 767
768 # Don't append another ";" when a valid category value is provided.
769 type=${type%;}${type:+;}
770
771 eshopts_push -s extglob
772 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
773 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
774 ewarn "allowed in .desktop files if the value is not an absolute path."
775 icon=${icon%.@(xpm|png|svg)}
776 fi
777 eshopts_pop
778
779 cat <<-EOF > "${desktop}"
898echo "[Desktop Entry] 780 [Desktop Entry]
899Encoding=UTF-8
900Version=0.9.2
901Name=${name} 781 Name=${name}
902Type=Application 782 Type=Application
903Comment=${DESCRIPTION} 783 Comment=${DESCRIPTION}
904Exec=${exec} 784 Exec=${exec}
905Path=${path} 785 TryExec=${exec%% *}
906Icon=${icon} 786 Icon=${icon}
907Categories=Application;${type};" > "${desktop}" 787 Categories=${type}
788 EOF
789
790 if [[ ${fields:-=} != *=* ]] ; then
791 # 5th arg used to be value to Path=
792 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
793 fields="Path=${fields}"
794 fi
795 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
908 796
909 ( 797 (
910 # wrap the env here so that the 'insinto' call 798 # wrap the env here so that the 'insinto' call
911 # doesn't corrupt the env of the caller 799 # doesn't corrupt the env of the caller
912 insinto /usr/share/applications 800 insinto /usr/share/applications
913 doins "${desktop}" 801 doins "${desktop}"
914 ) 802 ) || die "installing desktop file failed"
915} 803}
916 804
917# Make a GDM/KDM Session file 805# @FUNCTION: validate_desktop_entries
918# 806# @USAGE: [directories]
919# make_desktop_entry(<title>, <command>) 807# @MAINTAINER:
920# title: File to execute to start the Window Manager 808# Carsten Lohrke <carlo@gentoo.org>
921# command: Name of the Window Manager 809# @DESCRIPTION:
810# Validate desktop entries using desktop-file-utils
811validate_desktop_entries() {
812 if [[ -x /usr/bin/desktop-file-validate ]] ; then
813 einfo "Checking desktop entry validity"
814 local directories=""
815 for d in /usr/share/applications $@ ; do
816 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
817 done
818 if [[ -n ${directories} ]] ; then
819 for FILE in $(find ${directories} -name "*\.desktop" \
820 -not -path '*.hidden*' | sort -u 2>/dev/null)
821 do
822 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
823 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
824 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
825 done
826 fi
827 echo ""
828 else
829 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
830 fi
831}
922 832
833# @FUNCTION: make_session_desktop
834# @USAGE: <title> <command> [command args...]
835# @DESCRIPTION:
836# Make a GDM/KDM Session file. The title is the file to execute to start the
837# Window Manager. The command is the name of the Window Manager.
838#
839# You can set the name of the file via the ${wm} variable.
923make_session_desktop() { 840make_session_desktop() {
924 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 841 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
925 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 842 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
926 843
927 local title=$1 844 local title=$1
928 local command=$2 845 local command=$2
929 local desktop=${T}/${wm}.desktop 846 local desktop=${T}/${wm:-${PN}}.desktop
847 shift 2
930 848
849 cat <<-EOF > "${desktop}"
931echo "[Desktop Entry] 850 [Desktop Entry]
932Encoding=UTF-8
933Name=${title} 851 Name=${title}
934Comment=This session logs you into ${title} 852 Comment=This session logs you into ${title}
935Exec=${command} 853 Exec=${command} $*
936TryExec=${command} 854 TryExec=${command}
937Type=Application" > "${desktop}" 855 Type=XSession
856 EOF
938 857
858 (
859 # wrap the env here so that the 'insinto' call
860 # doesn't corrupt the env of the caller
939 insinto /usr/share/xsessions 861 insinto /usr/share/xsessions
940 doins "${desktop}" 862 doins "${desktop}"
863 )
941} 864}
942 865
866# @FUNCTION: domenu
867# @USAGE: <menus>
868# @DESCRIPTION:
869# Install the list of .desktop menu files into the appropriate directory
870# (/usr/share/applications).
943domenu() { 871domenu() {
872 (
873 # wrap the env here so that the 'insinto' call
874 # doesn't corrupt the env of the caller
944 local i j 875 local i j ret=0
945 insinto /usr/share/applications 876 insinto /usr/share/applications
946 for i in "$@" ; do 877 for i in "$@" ; do
947 if [[ -f ${i} ]] ; then 878 if [[ -f ${i} ]] ; then
948 doins "${i}" 879 doins "${i}"
880 ((ret+=$?))
949 elif [[ -d ${i} ]] ; then 881 elif [[ -d ${i} ]] ; then
950 for j in "${i}"/*.desktop ; do 882 for j in "${i}"/*.desktop ; do
951 doins "${j}" 883 doins "${j}"
884 ((ret+=$?))
952 done 885 done
886 else
887 ((++ret))
953 fi 888 fi
954 done 889 done
890 exit ${ret}
891 )
955} 892}
893
894# @FUNCTION: newmenu
895# @USAGE: <menu> <newname>
896# @DESCRIPTION:
897# Like all other new* functions, install the specified menu as newname.
956newmenu() { 898newmenu() {
899 (
900 # wrap the env here so that the 'insinto' call
901 # doesn't corrupt the env of the caller
957 insinto /usr/share/applications 902 insinto /usr/share/applications
958 newins "$1" "$2" 903 newins "$@"
904 )
959} 905}
960 906
907# @FUNCTION: doicon
908# @USAGE: <list of icons>
909# @DESCRIPTION:
910# Install the list of icons into the icon directory (/usr/share/pixmaps).
911# This is useful in conjunction with creating desktop/menu files.
961doicon() { 912doicon() {
913 (
914 # wrap the env here so that the 'insinto' call
915 # doesn't corrupt the env of the caller
962 local i j 916 local i j ret
963 insinto /usr/share/pixmaps 917 insinto /usr/share/pixmaps
964 for i in "$@" ; do 918 for i in "$@" ; do
965 if [[ -f ${i} ]] ; then 919 if [[ -f ${i} ]] ; then
966 doins "${i}" 920 doins "${i}"
921 ((ret+=$?))
967 elif [[ -d ${i} ]] ; then 922 elif [[ -d ${i} ]] ; then
968 for j in "${i}"/*.png ; do 923 for j in "${i}"/*.png ; do
969 doins "${j}" 924 doins "${j}"
925 ((ret+=$?))
970 done 926 done
927 else
928 ((++ret))
971 fi 929 fi
972 done 930 done
931 exit ${ret}
932 )
973} 933}
934
935# @FUNCTION: newicon
936# @USAGE: <icon> <newname>
937# @DESCRIPTION:
938# Like all other new* functions, install the specified icon as newname.
974newicon() { 939newicon() {
940 (
941 # wrap the env here so that the 'insinto' call
942 # doesn't corrupt the env of the caller
975 insinto /usr/share/pixmaps 943 insinto /usr/share/pixmaps
976 newins "$1" "$2" 944 newins "$@"
945 )
977} 946}
978 947
979############################################################## 948# @FUNCTION: cdrom_get_cds
980# END: Handle .desktop files and menu entries # 949# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
981############################################################## 950# @DESCRIPTION:
982
983
984# for internal use only (unpack_pdv and unpack_makeself)
985find_unpackable_file() {
986 local src=$1
987 if [[ -z ${src} ]] ; then
988 src=${DISTDIR}/${A}
989 else
990 if [[ -e ${DISTDIR}/${src} ]] ; then
991 src=${DISTDIR}/${src}
992 elif [[ -e ${PWD}/${src} ]] ; then
993 src=${PWD}/${src}
994 elif [[ -e ${src} ]] ; then
995 src=${src}
996 fi
997 fi
998 [[ ! -e ${src} ]] && return 1
999 echo "${src}"
1000}
1001
1002# Unpack those pesky pdv generated files ...
1003# They're self-unpacking programs with the binary package stuffed in
1004# the middle of the archive. Valve seems to use it a lot ... too bad
1005# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1006#
1007# Usage: unpack_pdv [file to unpack] [size of off_t]
1008# - you have to specify the off_t size ... i have no idea how to extract that
1009# information out of the binary executable myself. basically you pass in
1010# the size of the off_t type (in bytes) on the machine that built the pdv
1011# archive. one way to determine this is by running the following commands:
1012# strings <pdv archive> | grep lseek
1013# strace -elseek <pdv archive>
1014# basically look for the first lseek command (we do the strings/grep because
1015# sometimes the function call is _llseek or something) and steal the 2nd
1016# parameter. here is an example:
1017# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1018# lseek
1019# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1020# lseek(3, -4, SEEK_END) = 2981250
1021# thus we would pass in the value of '4' as the second parameter.
1022unpack_pdv() {
1023 local src=$(find_unpackable_file $1)
1024 local sizeoff_t=$2
1025
1026 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1027 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1028
1029 local shrtsrc=$(basename "${src}")
1030 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1031 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
1032 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
1033
1034 # grab metadata for debug reasons
1035 local metafile="$(emktemp)"
1036 tail -c +$((${metaskip}+1)) ${src} > ${metafile}
1037
1038 # rip out the final file name from the metadata
1039 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`"
1040 datafile="`basename ${datafile}`"
1041
1042 # now lets uncompress/untar the file if need be
1043 local tmpfile="$(emktemp)"
1044 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1045
1046 local iscompressed="`file -b ${tmpfile}`"
1047 if [ "${iscompressed:0:8}" == "compress" ] ; then
1048 iscompressed=1
1049 mv ${tmpfile}{,.Z}
1050 gunzip ${tmpfile}
1051 else
1052 iscompressed=0
1053 fi
1054 local istar="`file -b ${tmpfile}`"
1055 if [ "${istar:0:9}" == "POSIX tar" ] ; then
1056 istar=1
1057 else
1058 istar=0
1059 fi
1060
1061 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1062 #dd if=${src} ibs=${metaskip} count=1 \
1063 # | dd ibs=${tailskip} skip=1 \
1064 # | gzip -dc \
1065 # > ${datafile}
1066 if [ ${iscompressed} -eq 1 ] ; then
1067 if [ ${istar} -eq 1 ] ; then
1068 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1069 | head -c $((${metaskip}-${tailskip})) \
1070 | tar -xzf -
1071 else
1072 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1073 | head -c $((${metaskip}-${tailskip})) \
1074 | gzip -dc \
1075 > ${datafile}
1076 fi
1077 else
1078 if [ ${istar} -eq 1 ] ; then
1079 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1080 | head -c $((${metaskip}-${tailskip})) \
1081 | tar --no-same-owner -xf -
1082 else
1083 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1084 | head -c $((${metaskip}-${tailskip})) \
1085 > ${datafile}
1086 fi
1087 fi
1088 true
1089 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1090 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1091}
1092
1093# Unpack those pesky makeself generated files ...
1094# They're shell scripts with the binary package tagged onto
1095# the end of the archive. Loki utilized the format as does
1096# many other game companies.
1097#
1098# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1099# - If the file is not specified then unpack will utilize ${A}.
1100# - If the offset is not specified then we will attempt to extract
1101# the proper offset from the script itself.
1102unpack_makeself() {
1103 local src_input=${1:-${A}}
1104 local src=$(find_unpackable_file "${src_input}")
1105 local skip=$2
1106 local exe=$3
1107
1108 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1109
1110 local shrtsrc=$(basename "${src}")
1111 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1112 if [[ -z ${skip} ]] ; then
1113 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1114 local skip=0
1115 exe=tail
1116 case ${ver} in
1117 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1118 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1119 ;;
1120 2.0|2.0.1)
1121 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1122 ;;
1123 2.1.1)
1124 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1125 let skip="skip + 1"
1126 ;;
1127 2.1.2)
1128 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1129 let skip="skip + 1"
1130 ;;
1131 2.1.3)
1132 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1133 let skip="skip + 1"
1134 ;;
1135 2.1.4|2.1.5)
1136 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1137 skip=$(head -n ${skip} "${src}" | wc -c)
1138 exe="dd"
1139 ;;
1140 *)
1141 eerror "I'm sorry, but I was unable to support the Makeself file."
1142 eerror "The version I detected was '${ver}'."
1143 eerror "Please file a bug about the file ${shrtsrc} at"
1144 eerror "http://bugs.gentoo.org/ so that support can be added."
1145 die "makeself version '${ver}' not supported"
1146 ;;
1147 esac
1148 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1149 fi
1150 case ${exe} in
1151 tail) exe="tail -n +${skip} '${src}'";;
1152 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";;
1153 *) die "makeself cant handle exe '${exe}'"
1154 esac
1155
1156 # lets grab the first few bytes of the file to figure out what kind of archive it is
1157 local tmpfile="$(emktemp)"
1158 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1159 local filetype="$(file -b "${tmpfile}")"
1160 case ${filetype} in
1161 *tar\ archive)
1162 eval ${exe} | tar --no-same-owner -xf -
1163 ;;
1164 bzip2*)
1165 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1166 ;;
1167 gzip*)
1168 eval ${exe} | tar --no-same-owner -xzf -
1169 ;;
1170 compress*)
1171 eval ${exe} | gunzip | tar --no-same-owner -xf -
1172 ;;
1173 *)
1174 eerror "Unknown filetype \"${filetype}\" ?"
1175 false
1176 ;;
1177 esac
1178 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1179}
1180
1181# Display a license for user to accept.
1182#
1183# Usage: check_license [license]
1184# - If the file is not specified then ${LICENSE} is used.
1185check_license() {
1186 local lic=$1
1187 if [ -z "${lic}" ] ; then
1188 lic="${PORTDIR}/licenses/${LICENSE}"
1189 else
1190 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1191 lic="${PORTDIR}/licenses/${lic}"
1192 elif [ -e "${PWD}/${lic}" ] ; then
1193 lic="${PWD}/${lic}"
1194 elif [ -e "${lic}" ] ; then
1195 lic="${lic}"
1196 fi
1197 fi
1198 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1199 local l="`basename ${lic}`"
1200
1201 # here is where we check for the licenses the user already
1202 # accepted ... if we don't find a match, we make the user accept
1203 local shopts=$-
1204 local alic
1205 set -o noglob #so that bash doesn't expand "*"
1206 for alic in ${ACCEPT_LICENSE} ; do
1207 if [[ ${alic} == * || ${alic} == ${l} ]]; then
1208 set +o noglob; set -${shopts} #reset old shell opts
1209 return 0
1210 fi
1211 done
1212 set +o noglob; set -$shopts #reset old shell opts
1213
1214 local licmsg="$(emktemp)"
1215 cat << EOF > ${licmsg}
1216**********************************************************
1217The following license outlines the terms of use of this
1218package. You MUST accept this license for installation to
1219continue. When you are done viewing, hit 'q'. If you
1220CTRL+C out of this, the install will not run!
1221**********************************************************
1222
1223EOF
1224 cat ${lic} >> ${licmsg}
1225 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1226 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1227 read alic
1228 case ${alic} in
1229 yes|Yes|y|Y)
1230 return 0
1231 ;;
1232 *)
1233 echo;echo;echo
1234 eerror "You MUST accept the license to continue! Exiting!"
1235 die "Failed to accept license"
1236 ;;
1237 esac
1238}
1239
1240# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates 951# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1241# the whole 'non-interactive' policy, but damnit I want CD support ! 952# the whole 'non-interactive' policy, but damnit I want CD support !
1242# 953#
1243# with these cdrom functions we handle all the user interaction and 954# With these cdrom functions we handle all the user interaction and
1244# standardize everything. all you have to do is call cdrom_get_cds() 955# standardize everything. All you have to do is call cdrom_get_cds()
1245# and when the function returns, you can assume that the cd has been 956# and when the function returns, you can assume that the cd has been
1246# found at CDROM_ROOT. 957# found at CDROM_ROOT.
1247# 958#
959# The function will attempt to locate a cd based upon a file that is on
960# the cd. The more files you give this function, the more cds
961# the cdrom functions will handle.
962#
1248# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2', 963# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1249# etc... if you want to give the cds better names, then just export 964# etc... If you want to give the cds better names, then just export
1250# the CDROM_NAME_X variables before calling cdrom_get_cds(). 965# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
966# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
967# also use the CDROM_NAME_SET bash array.
1251# 968#
1252# for those multi cd ebuilds, see the cdrom_load_next_cd() below. 969# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1253#
1254# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1255# - this will attempt to locate a cd based upon a file that is on
1256# the cd ... the more files you give this function, the more cds
1257# the cdrom functions will handle
1258cdrom_get_cds() { 970cdrom_get_cds() {
1259 # first we figure out how many cds we're dealing with by 971 # first we figure out how many cds we're dealing with by
1260 # the # of files they gave us 972 # the # of files they gave us
1261 local cdcnt=0 973 local cdcnt=0
1262 local f= 974 local f=
1286 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 998 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1287 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 999 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1288 export CDROM_SET=-1 1000 export CDROM_SET=-1
1289 for f in ${CDROM_CHECK_1//:/ } ; do 1001 for f in ${CDROM_CHECK_1//:/ } ; do
1290 ((++CDROM_SET)) 1002 ((++CDROM_SET))
1291 [[ -e ${CD_ROOT}/${f} ]] && break 1003 [[ -e ${CDROM_ROOT}/${f} ]] && break
1292 done 1004 done
1293 export CDROM_MATCH=${f} 1005 export CDROM_MATCH=${f}
1294 return 1006 return
1295 fi 1007 fi
1296 1008
1306 echo 1018 echo
1307 einfo "For example:" 1019 einfo "For example:"
1308 einfo "export CD_ROOT=/mnt/cdrom" 1020 einfo "export CD_ROOT=/mnt/cdrom"
1309 echo 1021 echo
1310 else 1022 else
1023 if [[ -n ${CDROM_NAME_SET} ]] ; then
1024 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1025 cdcnt=0
1026 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1027 ((++cdcnt))
1028 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1029 done
1030 fi
1031
1311 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds." 1032 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1312 cdcnt=0 1033 cdcnt=0
1313 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1034 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1314 ((++cdcnt)) 1035 ((++cdcnt))
1315 var="CDROM_NAME_${cdcnt}" 1036 var="CDROM_NAME_${cdcnt}"
1339 export CDROM_SET="" 1060 export CDROM_SET=""
1340 export CDROM_CURRENT_CD=0 1061 export CDROM_CURRENT_CD=0
1341 cdrom_load_next_cd 1062 cdrom_load_next_cd
1342} 1063}
1343 1064
1344# this is only used when you need access to more than one cd. 1065# @FUNCTION: cdrom_load_next_cd
1345# when you have finished using the first cd, just call this function. 1066# @DESCRIPTION:
1346# when it returns, CDROM_ROOT will be pointing to the second cd. 1067# Some packages are so big they come on multiple CDs. When you're done reading
1347# remember, you can only go forward in the cd chain, you can't go back. 1068# files off a CD and want access to the next one, just call this function.
1069# Again, all the messy details of user interaction are taken care of for you.
1070# Once this returns, just read the variable CDROM_ROOT for the location of the
1071# mounted CD. Note that you can only go forward in the CD list, so make sure
1072# you only call this function when you're done using the current CD.
1348cdrom_load_next_cd() { 1073cdrom_load_next_cd() {
1349 local var 1074 local var
1350 ((++CDROM_CURRENT_CD)) 1075 ((++CDROM_CURRENT_CD))
1351 1076
1352 unset CDROM_ROOT 1077 unset CDROM_ROOT
1369# displayed and we'll hang out here until: 1094# displayed and we'll hang out here until:
1370# (1) the file is found on a mounted cdrom 1095# (1) the file is found on a mounted cdrom
1371# (2) the user hits CTRL+C 1096# (2) the user hits CTRL+C
1372_cdrom_locate_file_on_cd() { 1097_cdrom_locate_file_on_cd() {
1373 local mline="" 1098 local mline=""
1374 local showedmsg=0 1099 local showedmsg=0 showjolietmsg=0
1375 1100
1376 while [[ -z ${CDROM_ROOT} ]] ; do 1101 while [[ -z ${CDROM_ROOT} ]] ; do
1377 local i=0 1102 local i=0
1378 local -a cdset=(${*//:/ }) 1103 local -a cdset=(${*//:/ })
1379 if [[ -n ${CDROM_SET} ]] ; then 1104 if [[ -n ${CDROM_SET} ]] ; then
1382 1107
1383 while [[ -n ${cdset[${i}]} ]] ; do 1108 while [[ -n ${cdset[${i}]} ]] ; do
1384 local dir=$(dirname ${cdset[${i}]}) 1109 local dir=$(dirname ${cdset[${i}]})
1385 local file=$(basename ${cdset[${i}]}) 1110 local file=$(basename ${cdset[${i}]})
1386 1111
1387 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do 1112 local point= node= fs= foo=
1113 while read point node fs foo ; do
1114 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1115 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1116 && continue
1117 point=${point//\040/ }
1388 [[ -d ${mline}/${dir} ]] || continue 1118 [[ ! -d ${point}/${dir} ]] && continue
1389 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then 1119 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1390 export CDROM_ROOT=${mline} 1120 export CDROM_ROOT=${point}
1391 export CDROM_SET=${i} 1121 export CDROM_SET=${i}
1392 export CDROM_MATCH=${cdset[${i}]} 1122 export CDROM_MATCH=${cdset[${i}]}
1393 return 1123 return
1394 fi 1124 done <<< "$(get_mounts)"
1395 done
1396 1125
1397 ((++i)) 1126 ((++i))
1398 done 1127 done
1399 1128
1400 echo 1129 echo
1416 showedmsg=1 1145 showedmsg=1
1417 fi 1146 fi
1418 einfo "Press return to scan for the cd again" 1147 einfo "Press return to scan for the cd again"
1419 einfo "or hit CTRL+C to abort the emerge." 1148 einfo "or hit CTRL+C to abort the emerge."
1420 echo 1149 echo
1150 if [[ ${showjolietmsg} -eq 0 ]] ; then
1151 showjolietmsg=1
1152 else
1421 einfo "If you are having trouble with the detection" 1153 ewarn "If you are having trouble with the detection"
1422 einfo "of your CD, it is possible that you do not have" 1154 ewarn "of your CD, it is possible that you do not have"
1423 einfo "Joliet support enabled in your kernel. Please" 1155 ewarn "Joliet support enabled in your kernel. Please"
1424 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1156 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1425 read 1157 ebeep 5
1158 fi
1159 read || die "something is screwed with your system"
1426 done 1160 done
1427} 1161}
1428 1162
1163# @FUNCTION: strip-linguas
1164# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1165# @DESCRIPTION:
1429# Make sure that LINGUAS only contains languages that 1166# Make sure that LINGUAS only contains languages that
1430# a package can support 1167# a package can support. The first form allows you to
1431# 1168# specify a list of LINGUAS. The -i builds a list of po
1432# usage: strip-linguas <allow LINGUAS> 1169# files found in all the directories and uses the
1433# strip-linguas -i <directories of .po files> 1170# intersection of the lists. The -u builds a list of po
1434# strip-linguas -u <directories of .po files> 1171# files found in all the directories and uses the union
1435# 1172# of the lists.
1436# The first form allows you to specify a list of LINGUAS.
1437# The -i builds a list of po files found in all the
1438# directories and uses the intersection of the lists.
1439# The -u builds a list of po files found in all the
1440# directories and uses the union of the lists.
1441strip-linguas() { 1173strip-linguas() {
1442 local ls newls 1174 local ls newls nols
1443 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1175 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1444 local op=$1; shift 1176 local op=$1; shift
1445 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift 1177 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1446 local d f 1178 local d f
1447 for d in "$@" ; do 1179 for d in "$@" ; do
1448 if [[ ${op} == "-u" ]] ; then 1180 if [[ ${op} == "-u" ]] ; then
1449 newls=${ls} 1181 newls=${ls}
1450 else 1182 else
1451 newls="" 1183 newls=""
1452 fi 1184 fi
1453 for f in $(find "$d" -name '*.po' -printf '%f ') ; do 1185 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1454 if [[ ${op} == "-i" ]] ; then 1186 if [[ ${op} == "-i" ]] ; then
1455 [[ ${ls/ ${f} /} != ${ls} ]] && newls="${newls} ${f}" 1187 has ${f} ${ls} && newls="${newls} ${f}"
1456 else 1188 else
1457 [[ ${ls/ ${f} /} == ${ls} ]] && newls="${newls} ${f}" 1189 has ${f} ${ls} || newls="${newls} ${f}"
1458 fi 1190 fi
1459 done 1191 done
1460 ls=${newls} 1192 ls=${newls}
1461 done 1193 done
1462 ls=${ls//.po}
1463 else 1194 else
1464 ls=$@ 1195 ls="$@"
1465 fi 1196 fi
1466 1197
1467 ls=" ${ls} " 1198 nols=""
1468 newls="" 1199 newls=""
1469 for f in ${LINGUAS} ; do 1200 for f in ${LINGUAS} ; do
1470 if [[ ${ls/ ${f} /} != ${ls} ]] ; then 1201 if has ${f} ${ls} ; then
1471 newls="${newls} ${f}" 1202 newls="${newls} ${f}"
1472 else 1203 else
1473 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1204 nols="${nols} ${f}"
1474 fi 1205 fi
1475 done 1206 done
1476 if [[ -z ${newls} ]] ; then 1207 [[ -n ${nols} ]] \
1477 export LINGUAS="" 1208 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1478 else
1479 export LINGUAS=${newls:1} 1209 export LINGUAS=${newls:1}
1480 fi
1481} 1210}
1482 1211
1483# moved from kernel.eclass since they are generally useful outside of 1212# @FUNCTION: preserve_old_lib
1484# kernel.eclass -iggy (20041002) 1213# @USAGE: <libs to preserve> [more libs]
1485 1214# @DESCRIPTION:
1486# the following functions are useful in kernel module ebuilds, etc.
1487# for an example see ivtv or drbd ebuilds
1488
1489# set's ARCH to match what the kernel expects
1490set_arch_to_kernel() {
1491 i=10
1492 while ((i--)) ; do
1493 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1494 done
1495 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1496 case ${ARCH} in
1497 x86) export ARCH="i386";;
1498 amd64) export ARCH="x86_64";;
1499 hppa) export ARCH="parisc";;
1500 mips) export ARCH="mips";;
1501 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1502 *) export ARCH="${ARCH}";;
1503 esac
1504}
1505
1506# set's ARCH back to what portage expects
1507set_arch_to_portage() {
1508 i=10
1509 while ((i--)) ; do
1510 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1511 done
1512 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1513}
1514
1515# Jeremy Huddleston <eradicator@gentoo.org>:
1516# preserve_old_lib /path/to/libblah.so.0
1517# preserve_old_lib_notify /path/to/libblah.so.0
1518#
1519# These functions are useful when a lib in your package changes --soname. Such 1215# These functions are useful when a lib in your package changes ABI SONAME.
1520# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1216# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1521# would break packages that link against it. Most people get around this 1217# would break packages that link against it. Most people get around this
1522# by using the portage SLOT mechanism, but that is not always a relevant 1218# by using the portage SLOT mechanism, but that is not always a relevant
1523# solution, so instead you can add the following to your ebuilds: 1219# solution, so instead you can call this from pkg_preinst. See also the
1524# 1220# preserve_old_lib_notify function.
1525# src_install() {
1526# ...
1527# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1528# ...
1529# }
1530#
1531# pkg_postinst() {
1532# ...
1533# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1534# ...
1535# }
1536
1537preserve_old_lib() { 1221preserve_old_lib() {
1538 LIB=$1 1222 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1223 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1224 die "Invalid preserve_old_lib() usage"
1225 fi
1226 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1539 1227
1540 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1228 # let portage worry about it
1541 SONAME=`basename ${LIB}` 1229 has preserve-libs ${FEATURES} && return 0
1542 DIRNAME=`dirname ${LIB}`
1543 1230
1544 dodir ${DIRNAME} 1231 local lib dir
1545 cp ${ROOT}${LIB} ${D}${DIRNAME} 1232 for lib in "$@" ; do
1233 [[ -e ${ROOT}/${lib} ]] || continue
1234 dir=${lib%/*}
1235 dodir ${dir} || die "dodir ${dir} failed"
1236 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1546 touch ${D}${LIB} 1237 touch "${D}"/${lib}
1547 fi 1238 done
1548} 1239}
1549 1240
1241# @FUNCTION: preserve_old_lib_notify
1242# @USAGE: <libs to notify> [more libs]
1243# @DESCRIPTION:
1244# Spit helpful messages about the libraries preserved by preserve_old_lib.
1550preserve_old_lib_notify() { 1245preserve_old_lib_notify() {
1551 LIB=$1 1246 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1247 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1248 die "Invalid preserve_old_lib_notify() usage"
1249 fi
1552 1250
1553 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1251 # let portage worry about it
1554 SONAME=`basename ${LIB}` 1252 has preserve-libs ${FEATURES} && return 0
1555 1253
1254 local lib notice=0
1255 for lib in "$@" ; do
1256 [[ -e ${ROOT}/${lib} ]] || continue
1257 if [[ ${notice} -eq 0 ]] ; then
1258 notice=1
1556 ewarn "An old version of an installed library was detected on your system." 1259 ewarn "Old versions of installed libraries were detected on your system."
1557 ewarn "In order to avoid breaking packages that link against it, this older version" 1260 ewarn "In order to avoid breaking packages that depend on these old libs,"
1558 ewarn "is not being removed. In order to make full use of this newer version," 1261 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1559 ewarn "you will need to execute the following command:" 1262 ewarn "in order to remove these old dependencies. If you do not have this"
1560 ewarn " revdep-rebuild --soname ${SONAME}" 1263 ewarn "helper program, simply emerge the 'gentoolkit' package."
1264 ewarn
1265 fi
1266 # temp hack for #348634 #357225
1267 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1268 ewarn " # revdep-rebuild --library '${lib}'"
1269 done
1270 if [[ ${notice} -eq 1 ]] ; then
1561 ewarn 1271 ewarn
1562 ewarn "After doing that, you can safely remove ${LIB}" 1272 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1563 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild" 1273 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1274 for lib in "$@" ; do
1275 ewarn " # rm '${lib}'"
1276 done
1564 fi 1277 fi
1565} 1278}
1566 1279
1567# Hack for people to figure out if a package was built with 1280# @FUNCTION: built_with_use
1568# certain USE flags 1281# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1282# @DESCRIPTION:
1569# 1283#
1570# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1284# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1571# ex: built_with_use xchat gtk2
1572# 1285#
1573# Flags: -a all USE flags should be utilized 1286# A temporary hack until portage properly supports DEPENDing on USE
1574# -o at least one USE flag should be utilized 1287# flags being enabled in packages. This will check to see if the specified
1575# Note: the default flag is '-a' 1288# DEPEND atom was built with the specified list of USE flags. The
1289# --missing option controls the behavior if called on a package that does
1290# not actually support the defined USE flags (aka listed in IUSE).
1291# The default is to abort (call die). The -a and -o flags control
1292# the requirements of the USE flags. They correspond to "and" and "or"
1293# logic. So the -a flag means all listed USE flags must be enabled
1294# while the -o flag means at least one of the listed IUSE flags must be
1295# enabled. The --hidden option is really for internal use only as it
1296# means the USE flag we're checking is hidden expanded, so it won't be found
1297# in IUSE like normal USE flags.
1298#
1299# Remember that this function isn't terribly intelligent so order of optional
1300# flags matter.
1576built_with_use() { 1301built_with_use() {
1302 local hidden="no"
1303 if [[ $1 == "--hidden" ]] ; then
1304 hidden="yes"
1305 shift
1306 fi
1307
1308 local missing_action="die"
1309 if [[ $1 == "--missing" ]] ; then
1310 missing_action=$2
1311 shift ; shift
1312 case ${missing_action} in
1313 true|false|die) ;;
1314 *) die "unknown action '${missing_action}'";;
1315 esac
1316 fi
1317
1577 local opt=$1 1318 local opt=$1
1578 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1319 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1579 1320
1580 local PKG=$(best_version $1) 1321 local PKG=$(best_version $1)
1322 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1581 shift 1323 shift
1582 1324
1583 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1325 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1326 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1584 1327
1585 # if the USE file doesnt exist, assume the $PKG is either 1328 # if the IUSE file doesn't exist, the read will error out, we need to handle
1586 # injected or package.provided 1329 # this gracefully
1587 [[ ! -e ${USEFILE} ]] && return 0 1330 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1331 case ${missing_action} in
1332 true) return 0;;
1333 false) return 1;;
1334 die) die "Unable to determine what USE flags $PKG was built with";;
1335 esac
1336 fi
1337
1338 if [[ ${hidden} == "no" ]] ; then
1339 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1340 # Don't check USE_EXPAND #147237
1341 local expand
1342 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1343 if [[ $1 == ${expand}_* ]] ; then
1344 expand=""
1345 break
1346 fi
1347 done
1348 if [[ -n ${expand} ]] ; then
1349 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1350 case ${missing_action} in
1351 true) return 0;;
1352 false) return 1;;
1353 die) die "$PKG does not actually support the $1 USE flag!";;
1354 esac
1355 fi
1356 fi
1357 fi
1588 1358
1589 local USE_BUILT=$(<${USEFILE}) 1359 local USE_BUILT=$(<${USEFILE})
1590 while [[ $# -gt 0 ]] ; do 1360 while [[ $# -gt 0 ]] ; do
1591 if [[ ${opt} = "-o" ]] ; then 1361 if [[ ${opt} = "-o" ]] ; then
1592 has $1 ${USE_BUILT} && return 0 1362 has $1 ${USE_BUILT} && return 0
1596 shift 1366 shift
1597 done 1367 done
1598 [[ ${opt} = "-a" ]] 1368 [[ ${opt} = "-a" ]]
1599} 1369}
1600 1370
1371# @FUNCTION: epunt_cxx
1372# @USAGE: [dir to scan]
1373# @DESCRIPTION:
1601# Many configure scripts wrongly bail when a C++ compiler 1374# Many configure scripts wrongly bail when a C++ compiler could not be
1602# could not be detected. #73450 1375# detected. If dir is not specified, then it defaults to ${S}.
1376#
1377# http://bugs.gentoo.org/73450
1603epunt_cxx() { 1378epunt_cxx() {
1604 local dir=$1 1379 local dir=$1
1605 [[ -z ${dir} ]] && dir=${S} 1380 [[ -z ${dir} ]] && dir=${S}
1606 ebegin "Removing useless C++ checks" 1381 ebegin "Removing useless C++ checks"
1607 local f 1382 local f
1608 for f in $(find ${dir} -name configure) ; do 1383 find "${dir}" -name configure | while read f ; do
1609 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1384 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1610 done 1385 done
1611 eend 0 1386 eend 0
1612} 1387}
1613 1388
1614# dopamd <file> [more files] 1389# @FUNCTION: make_wrapper
1615# 1390# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1616# Install pam auth config file in /etc/pam.d 1391# @DESCRIPTION:
1617dopamd() { 1392# Create a shell wrapper script named wrapper in installpath
1618 [[ -z $1 ]] && die "dopamd requires at least one argument" 1393# (defaults to the bindir) to execute target (default of wrapper) by
1619 1394# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1620 use pam || return 0 1395# libpaths followed by optionally changing directory to chdir.
1621
1622 INSDESTTREE=/etc/pam.d \
1623 doins "$@" || die "failed to install $@"
1624}
1625# newpamd <old name> <new name>
1626#
1627# Install pam file <old name> as <new name> in /etc/pam.d
1628newpamd() {
1629 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1630
1631 use pam || return 0
1632
1633 INSDESTTREE=/etc/pam.d \
1634 newins "$1" "$2" || die "failed to install $1 as $2"
1635}
1636
1637# make a wrapper script ...
1638# NOTE: this was originally games_make_wrapper, but I noticed other places where
1639# this could be used, so I have moved it here and made it not games-specific
1640# -- wolf31o2
1641# $1 == wrapper name
1642# $2 == binary to run
1643# $3 == directory to chdir before running binary
1644# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1645# $5 == path for wrapper
1646make_wrapper() { 1396make_wrapper() {
1647 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1397 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1648 local tmpwrapper=$(emktemp) 1398 local tmpwrapper=$(emktemp)
1649 # We don't want to quote ${bin} so that people can pass complex 1399 # We don't want to quote ${bin} so that people can pass complex
1650 # things as $bin ... "./someprog --args" 1400 # things as $bin ... "./someprog --args"
1660fi 1410fi
1661exec ${bin} "\$@" 1411exec ${bin} "\$@"
1662EOF 1412EOF
1663 chmod go+rx "${tmpwrapper}" 1413 chmod go+rx "${tmpwrapper}"
1664 if [[ -n ${path} ]] ; then 1414 if [[ -n ${path} ]] ; then
1415 (
1665 exeinto "${path}" 1416 exeinto "${path}"
1666 newexe "${tmpwrapper}" "${wrapper}" 1417 newexe "${tmpwrapper}" "${wrapper}"
1418 ) || die
1667 else 1419 else
1668 newbin "${tmpwrapper}" "${wrapper}" 1420 newbin "${tmpwrapper}" "${wrapper}" || die
1421 fi
1422}
1423
1424# @FUNCTION: path_exists
1425# @USAGE: [-a|-o] <paths>
1426# @DESCRIPTION:
1427# Check if the specified paths exist. Works for all types of paths
1428# (files/dirs/etc...). The -a and -o flags control the requirements
1429# of the paths. They correspond to "and" and "or" logic. So the -a
1430# flag means all the paths must exist while the -o flag means at least
1431# one of the paths must exist. The default behavior is "and". If no
1432# paths are specified, then the return value is "false".
1433path_exists() {
1434 local opt=$1
1435 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1436
1437 # no paths -> return false
1438 # same behavior as: [[ -e "" ]]
1439 [[ $# -eq 0 ]] && return 1
1440
1441 local p r=0
1442 for p in "$@" ; do
1443 [[ -e ${p} ]]
1444 : $(( r += $? ))
1445 done
1446
1447 case ${opt} in
1448 -a) return $(( r != 0 )) ;;
1449 -o) return $(( r == $# )) ;;
1450 esac
1451}
1452
1453# @FUNCTION: in_iuse
1454# @USAGE: <flag>
1455# @DESCRIPTION:
1456# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1457# as necessary.
1458#
1459# Note that this function should not be used in the global scope.
1460in_iuse() {
1461 debug-print-function ${FUNCNAME} "${@}"
1462 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1463
1464 local flag=${1}
1465 local liuse=( ${IUSE} )
1466
1467 has "${flag}" "${liuse[@]#[+-]}"
1468}
1469
1470# @FUNCTION: use_if_iuse
1471# @USAGE: <flag>
1472# @DESCRIPTION:
1473# Return true if the given flag is in USE and IUSE.
1474#
1475# Note that this function should not be used in the global scope.
1476use_if_iuse() {
1477 in_iuse $1 || return 1
1478 use $1
1479}
1480
1481# @FUNCTION: usex
1482# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1483# @DESCRIPTION:
1484# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1485# otherwise echo [false output][false suffix] (defaults to "no").
1486usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1487
1488check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1489
1669 fi 1490fi
1670}

Legend:
Removed from v.1.218  
changed lines
  Added in v.1.382

  ViewVC Help
Powered by ViewVC 1.1.20